package com.gic.cloud.service.impl;

import com.gic.cloud.dao.mapper.TabIndexDescMapper;
import com.gic.cloud.dto.IndexDescDTO;
import com.gic.cloud.entity.TabIndexDesc;
import com.gic.cloud.service.IndexDescEnterpriseService;
import com.gic.cloud.service.IndexDescService;
import com.github.pagehelper.PageHelper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * @author zhiwj
 * @Description:
 * @date 2020-07-23 15:11
 */
@Service
public class IndexDescServiceImpl implements IndexDescService {

    @Autowired
    private TabIndexDescMapper tabIndexDescMapper;
    @Autowired
    private IndexDescEnterpriseService indexDescEnterpriseService;

    @Override
    public List<IndexDescDTO> listByEnterpriseAndModule(Integer enterpriseId, String moduleId, String indexGroupName) {
        return tabIndexDescMapper.listByEnterpriseAndModule(enterpriseId, moduleId, indexGroupName);
    }

    @Override
    public List<IndexDescDTO> listByEnterpriseAndModuleDetail(Integer enterpriseId, String moduleId, String indexGroupName, Integer userId) {
        return tabIndexDescMapper.listByEnterpriseAndModuleDetail(enterpriseId, moduleId, indexGroupName, userId, 1);
    }

    @Override
    public List<IndexDescDTO> listRecycle(Integer enterpriseId, String moduleId, String indexGroupName, Integer userId) {
        return tabIndexDescMapper.listByEnterpriseAndModuleDetail(enterpriseId, moduleId, indexGroupName, userId, 0);
    }

    @Override
    public void sort(Integer enterpriseId, String moduleId, String indexGroupName, Integer indexDescEnterpriseId, Integer seq) {
        PageHelper.offsetPage(seq - 1, 1);
        List<IndexDescDTO> dtoList = tabIndexDescMapper.listByEnterpriseAndModuleDetail(enterpriseId, moduleId, indexGroupName, null, 1);
        IndexDescDTO indexDescDTO = dtoList.get(0);
        indexDescEnterpriseService.updateSort(enterpriseId, indexDescEnterpriseId, indexDescDTO.getSort());
    }

    @Override
    public TabIndexDesc getIndexDesc(Integer enterpriseId, Integer indexDescId) {
        return tabIndexDescMapper.selectByPrimaryKey(indexDescId);
    }
}
