package com.gic.cloud.web.controller;

import com.alibaba.fastjson.JSON;
import com.gic.api.base.commons.Page;
import com.gic.api.base.commons.ServiceResponse;
import com.gic.cloud.web.qo.DateTypeQo;
import com.gic.cloud.web.vo.BaseSalesVo;
import com.gic.commons.webapi.reponse.RestResponse;
import com.gic.data.api.dto.BaseSalesDTO;
import com.gic.data.api.dto.BaseSalesParamsDTO;
import com.gic.data.api.service.BaseSalesApiService;
import org.apache.commons.collections.CollectionUtils;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;

@RestController
public class BaseSalesController {
    @Autowired
    private StoreSearchUtils storeSearchUtils;
    @Autowired
    private BaseSalesApiService baseSalesApiService;

    @RequestMapping("base-sales")
    public RestResponse baseSales(Integer channel, Integer userId, Integer enterpriseId, String searchJSON,
                                  DateTypeQo dateTypeQo, String mbrAreaId, Integer level, Integer parentId,
                                  Integer pageNum, Integer pageSize){
        List<Integer> list = this.storeSearchUtils.storeSearch(userId, enterpriseId, searchJSON);
        List<String> onLine = this.storeSearchUtils.onLineStoreSearch(userId, enterpriseId, searchJSON);
        List<Integer> childrenStoreGroupIdList = this.storeSearchUtils.getChildrenStoreGroupIdList(parentId);
        BaseSalesParamsDTO dto = new BaseSalesParamsDTO();
        dto.setChannel(channel);
        dto.setEnterpriseId(enterpriseId);
        dto.setStoreInfoIdList(list);
        dto.setOnLine(onLine);
        dto.setMbrAreaId(StringUtils.isBlank(mbrAreaId) ? null : Long.valueOf(mbrAreaId));
        dto.setType(dateTypeQo.getType());
        dto.setDate(dateTypeQo.getDate());
        dto.setChildrenStoreGroupIdList(childrenStoreGroupIdList);
        dto.setLevel(level);
        dto.setPageNum(pageNum);
        dto.setPageSize(pageSize);
        ServiceResponse<Page<BaseSalesDTO>> response = this.baseSalesApiService.pageBaseSales(dto);
        BaseSalesVo vo = new BaseSalesVo();
        vo.setPage(response.getResult());
        dto.setCountType(2);//合计
        ServiceResponse<Page<BaseSalesDTO>> response1 = this.baseSalesApiService.pageBaseSales(dto);
        if(response1.isSuccess() && response1.getResult() != null && CollectionUtils.isNotEmpty(response1.getResult().getResult())){
            vo.setTotal(response1.getResult().getResult().get(0));
        }
        if(channel == 1 && parentId == null){
            dto.setCountType(3); //无归属
            ServiceResponse<Page<BaseSalesDTO>> response2 = this.baseSalesApiService.pageBaseSales(dto);
            if(response2.isSuccess() && response2.getResult() != null && CollectionUtils.isNotEmpty(response2.getResult().getResult())){
                vo.setWgs(response2.getResult().getResult().get(0));
            }
        }
        return  RestResponse.success(vo);
    }
}
