package com.gic.cloud.web.controller;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import com.alibaba.fastjson.JSON;
import com.gic.commons.webapi.reponse.RestResponse;
import com.gic.data.api.qo.consumestructure.AgeConsumeShareQO;
import com.gic.data.api.service.consumestructure.ConsumeStructureApiService;
import com.gic.enterprise.utils.ResultControllerUtils;

@RestController
public class ConsumeStructureController {
    private static final Logger log = LogManager.getLogger(ConsumeStructureController.class);
    @Autowired
    private ConsumeStructureApiService consumeStructureApiService;
    @Autowired
    private StoreSearchUtils storeSearchUtils;

    /**
     * 年龄消费占比（订单人数/订单数/销售额）
     * @Title: queryAgeConsumeShare 
     * @Description:
     * @author guojuxing
     * @param params 
     * @return  com.gic.commons.webapi.reponse.RestResponse 
     */
    @RequestMapping("get-age-consume-share")
    public RestResponse queryAgeConsumeShare(AgeConsumeShareQO params) {
        log.info("消费构成-消费年龄-年龄消费占比参数：{}", JSON.toJSONString(params));
        params.setOnlineStoreIdList(storeSearchUtils.onLineStoreSearch(params.getUserId(), params.getEnterpriseId(), params.getSearchJson()));
        params.setStoreInfoIdList(storeSearchUtils.storeSearch(params.getUserId(), params.getEnterpriseId(), params.getSearchJson()));
        return ResultControllerUtils.commonResult(consumeStructureApiService.queryAgeConsumeShare(params));
    }

    @RequestMapping("get-age-consume-survey")
    public RestResponse queryAgeConsumeSurvey(AgeConsumeShareQO params) {
        log.info("消费构成-消费年龄-概况参数：{}", JSON.toJSONString(params));
        params.setOnlineStoreIdList(storeSearchUtils.onLineStoreSearch(params.getUserId(), params.getEnterpriseId(), params.getSearchJson()));
        params.setStoreInfoIdList(storeSearchUtils.storeSearch(params.getUserId(), params.getEnterpriseId(), params.getSearchJson()));
        return ResultControllerUtils.commonResult(consumeStructureApiService.queryAgeConsumeSurvey(params));
    }
}
